diff --git a/muxers.c b/muxers.c
index 770bb4c..5444c73 100644
--- a/muxers.c
+++ b/muxers.c
@@ -676,6 +676,20 @@ int set_param_mp4( hnd_t handle, x264_param_t *p_param )
     gf_isom_set_visual_info(p_mp4->p_file, p_mp4->i_track, p_mp4->i_descidx,
         p_param->i_width, p_param->i_height);
 
+    if( p_param->vui.i_sar_width && p_param->vui.i_sar_height ){
+        u32 dw = p_param->i_width,
+            dh = p_param->i_height;
+        double sar = (double)p_param->vui.i_sar_width / p_param->vui.i_sar_height;
+	if( sar > 1.0 ){
+	  dw *= sar;
+	}else{
+	  dh /= sar;
+	}
+
+	gf_isom_set_track_layout_info( p_mp4->p_file, p_mp4->i_track, 
+	    dw <<16, dh <<16, 0, 0, 0 );
+    }
+
     p_mp4->p_sample->data = (char *)malloc(p_param->i_width * p_param->i_height * 3 / 2);
     if (p_mp4->p_sample->data == NULL)
         return -1;
